#-----------------------------------------------------------------------------
#                            CarthaGene
#
# Martin Bouchez, Patrick Chabrier, Christine Gaspin and Thomas Schiex. 
# Unite de Biometrie et Intelligence Artificielle, Toulouse, France
#
#  Copyright (C) 1997 INRA (Institut National de la Recherche Agronomique).
#
# $Id: contrib.tcl,v 1.1 2003/01/07 17:08:03 chabrier Exp $
#
#    This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Module        : cgscript
# Projet        : CartaGene
#
# Description : features implemented in tcl only
#
# Divers : 
#-----------------------------------------------------------------------------
#-INRA---------------------Station de Biomtrie et d'Intelligence Artificielle
#-----------------------------------------------------------------------------

#
# features implemented in tcl
#

# print the best map
proc bestprint {} {
    maprint [lindex [lindex [heapget k 1] 0 ] 0]
}

# print in detail the best map
proc bestprintd {} {
    maprintd [lindex [lindex [heapget k 1] 0 ] 0]
}

proc mrkdel { mrk } {
	# to get the id of the marker
	set id [mrkid $mrk]
	# to get the selection
	set sel [mrkselget]
	# to remove
	set pos [lsearch $sel $id]
	set nsel [lreplace $sel $pos $pos]
	# to set the selection
	mrkselset $nsel
}

# add a set of markers from their loci ids
proc mrkadd {args} {
     set loc "[mrkselget] "
     append loc $args
     mrkselset $loc
}

# remove a set of markers from their loci ids 

proc mrksub {args} {
     set loc " [mrkselget] "
     foreach item $args {
        regsub " $item " $loc " " res
        set loc $res
      }
      mrkselset $loc
}

# returns the ids of several markers
proc mrkids {args} {
     set args [join $args]
     foreach item $args {
     lappend loc [mrkid $item]
}
return $loc	    
}

#returns the names of several markers ids

proc mrknames {args} {
     set args [join $args]
     foreach item $args {
     lappend loc [mrkname $item]
}
return $loc	    
}

