//-----------------------------------------------------------------------------
//                            CarthaGene
//
// Martin Bouchez, Patrick Chabrier, Christine Gaspin and Thomas Schiex. 
// Unite de Biometrie et Intelligence Artificielle, Toulouse, France
//
// Copyright 1997 INRA (Institut National de la Recherche Agronomique).
// This file is distributed under the terms of the Q Public License version 1.0.
// 
// $Id: System.h,v 1.17 2003/03/19 14:27:31 bouchez Exp $
//
// Description : Prototype de la classe Chronometre.
//
// Divers :
//----------------------------------------------------------------------------

#ifndef _SYSTEM_H
#define _SYSTEM_H

#include <stdio.h>

extern char bouf[1024];
extern char boufi[1024];
extern FILE *Fout;

#ifdef ihm
#include "tcl.h"
/** Concatnation  la fin du Widget */
extern Tcl_Interp *linterp;
#define pout(bouf) sprintf(boufi, "puts -nonewline {%s}; flush stdout", bouf); Tcl_Eval(linterp, boufi); if (Fout != NULL) fprintf(Fout, "%s", bouf)
#define perr(bouf) sprintf(boufi, "puts -nonewline stderr {%s}", bouf); Tcl_Eval(linterp, boufi); if (Fout != NULL) fprintf(Fout, "%s", bouf)
#else
#ifdef tcl
#include "tcl.h"
/** Exploitation de la sortie Tcl */
#define pout(bouf) Tcl_Write(fout,bouf,strlen(bouf)); Tcl_Flush(fout); if (Fout != NULL) fprintf(Fout, "%s", bouf)
#define perr(bouf) Tcl_Write(ferr,bouf,strlen(bouf)); if (Fout != NULL) fprintf(Fout, "%s", bouf)
#else
/** C*/
#define pout(bouf) printf(bouf); if (Fout != NULL) fprintf(Fout, "%s", bouf)
#define perr(bouf) fprintf(stderr, bouf); if (Fout != NULL) fprintf(Fout, "%s", bouf)
#endif
#endif

#ifdef tcl
  /** Exploitation de la sortie Tcl */
extern Tcl_Channel fout;
extern Tcl_Channel ferr;
#endif

#ifdef __WIN32__
#include <time.h>
#else
#include <stdlib.h>  // drand48() pour Solaris et Linux
#include <sys/times.h>
#endif

#define randomax(x) ((int) ((x)*drand48()))
#define Echange(x,y) { int _temp; _temp = *x; *x=*y; *y=_temp;}

#define MOD(i,n)    ((i) % (n) >= 0 ? (i) % (n) : (i) % (n) + (n))
#define RREAL drand48()

#ifdef __WIN32__
   extern double drand48( void );
#endif

/* license */
int CheckDoor();

/** Indicateur du temps coul depuis le lancement de la recherche.
  */
class Chronometre {
 public:

  /** Le start du chronomtre.
      Remise  zro du compteur qui enregistre l'heure courante.
    */
  void Init(void);

  /** Donne le temps coul depuis l'initialisation de l'objet.
    */
  double Read(void) const;

 private:
#ifdef __WIN32__
  time_t InitialTime;
#else
  /** Structure tms o est mmorise l'heure au moment du lancement du
      chronomtre.
      */
  tms InitialTime;
#endif
};

char *Cart_basename( const char*  name );

#endif /* _SYSTEM_H */
